﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ParametricIteratorMethods {

	class A {
		public int x;

		public IEnumerable<int> Range(int from, int to) {
			Console.WriteLine("+ A.Range: before 1st yield return");
			from--;
			to++;
			for (int i = from; i <= to; i++) {
				yield return x + i;
			}
			x += 100;
			Console.WriteLine("+ A.Range: after last yield return");
		}
	}

	class Program {
		static void Main(string[] args) {
			A a = new A();

			var range = a.Range(1, 2);

			for (int i = 0; i < 2; i++) {
				Console.WriteLine($"Main: before foreach #{i}");
                foreach (int v in range) {
					Console.WriteLine("Main: got {0}", v);
				}
				Console.WriteLine($"Main: after foreach #{i}");
			}
		}
	}
}
